/**
    PSPComic - xmlfuncs.hpp
    Copyright (C) 2007  Jeffrey P.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
**/

#ifndef PSPComic_xmlfuncs_hpp
#define PSPComic_xmlfuncs_hpp

#include "pspcomic.h"

#ifdef __cplusplus__
extern "C" {
#endif

enum {
	xml_er_unknown = -1,
	xml_er_cannot_load = -2,
	xml_er_malformed = -4,
	xml_er_out_of_memory = -8
};

//Configuration file functions
char load_config();
char save_config();

//Bookmark functions
char load_bookmarks();
char save_bookmark(comic_book *book);
Sint32 get_bookmark(char *book);
char delete_bookmarks(char *book);
char purge_bookmarks();
char delete_all_bookmarks();

#ifdef __cplusplus__
}
#endif

#endif
